OGRE: Ogre::Codec Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::Codec Class Referenceabstract
Core » General

Abstract class that defines a 'codec'. More...

`#include <OgreCodec.h>`

Inheritance diagram for Ogre::Codec:
[legend]

## Public Member Functions
virtual | ~Codec ()
virtual void | decode (const DataStreamPtr &input, const Any &output) const =0
| Codes the data from the input chunk into the output chunk.
virtual DataStreamPtr | encode (const Any &input) const
| Codes the input and saves the result in the output stream.
virtual void | encodeToFile (const Any &input, const String &outFileName) const
| Codes the data in the input chunk and saves the result in the output filename provided.
virtual String | getType () const =0
| Returns the type of the codec as a String.
bool | magicNumberMatch (const char *magicNumberPtr, size_t maxbytes) const
| Returns whether a magic number header matches this codec.
virtual String | magicNumberToFileExt (const char *magicNumberPtr, size_t maxbytes) const =0
| Maps a magic number header to a file extension, if this codec recognises it.
virtual bool | setParameter (const String &name, const String &value)

## Static Public Member Functions
static Codec * | getCodec (char *magicNumberPtr, size_t maxbytes)
| Gets the codec that can handle the given 'magic' identifier.
static Codec * | getCodec (const String &extension)
| Gets the codec registered for the passed in file extension.
static StringVector | getExtensions (void)
| Gets the file extension list for the registered codecs.
static bool | isCodecRegistered (const String &codecType)
| Return whether a codec is registered already.
static void | registerCodec (Codec *pCodec)
| Registers a new codec in the database.
static void | unregisterCodec (Codec *pCodec)
| Unregisters a codec from the database.

## Detailed Description

Abstract class that defines a 'codec'.

A codec class works like a two-way filter for data - data entered on one end (the decode end) gets processed and transformed into easily usable data while data passed the other way around codes it back.

  The codec concept is a pretty generic one - you can easily understand how it can be used for images, sounds, archives, even compressed data.

## Constructor & Destructor Documentation

## ◆ ~Codec()

virtual Ogre::Codec::~Codec | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ registerCodec()

void Ogre::Codec::registerCodec | ( | Codec * | pCodec | ) |
| static

Registers a new codec in the database.

## ◆ isCodecRegistered()

bool Ogre::Codec::isCodecRegistered | ( | const String & | codecType | ) |
| inlinestatic

Return whether a codec is registered already.

## ◆ unregisterCodec()

void Ogre::Codec::unregisterCodec | ( | Codec * | pCodec | ) |
| inlinestatic

Unregisters a codec from the database.

References getType().

## ◆ getExtensions()

StringVector Ogre::Codec::getExtensions | ( | void |  | ) |
| static

Gets the file extension list for the registered codecs.

## ◆ getCodec() [1/2]

Codec * Ogre::Codec::getCodec | ( | const String & | extension | ) |
| static

Gets the codec registered for the passed in file extension.

## ◆ getCodec() [2/2]

Codec * Ogre::Codec::getCodec | ( | char * | magicNumberPtr,
|  | size_t | maxbytes )
| static

Gets the codec that can handle the given 'magic' identifier.

Parameters

  magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  maxbytes | The number of bytes passed

## ◆ encode()

virtual DataStreamPtr Ogre::Codec::encode | ( | const Any & | input | ) | const
| virtual

Codes the input and saves the result in the output stream.

Reimplemented in Ogre::FreeImageCodec, Ogre::RsImageCodec, and Ogre::STBIImageCodec.

## ◆ encodeToFile()

virtual void Ogre::Codec::encodeToFile | ( | const Any & | input,
|  | const String & | outFileName ) const
| virtual

Codes the data in the input chunk and saves the result in the output filename provided.

Provided for efficiency since coding to memory is progressive therefore memory required is unknown leading to reallocations.

Parameters

  input | The input data (codec type specific)
  outFileName | The filename to write to

Reimplemented in Ogre::FreeImageCodec, Ogre::RsImageCodec, and Ogre::STBIImageCodec.

## ◆ decode()

virtual void Ogre::Codec::decode | ( | const DataStreamPtr & | input,
|  | const Any & | output ) const
| pure virtual

Codes the data from the input chunk into the output chunk.

Parameters

  input | Stream containing the encoded data
  output | codec type specific result

Implemented in Ogre::EXRCodec, Ogre::FreeImageCodec, Ogre::RsImageCodec, and Ogre::STBIImageCodec.

## ◆ getType()

virtual String Ogre::Codec::getType | ( |  | ) | const
| pure virtual

Returns the type of the codec as a String.

Implemented in Ogre::EXRCodec, Ogre::FreeImageCodec, Ogre::RsImageCodec, and Ogre::STBIImageCodec.

Referenced by unregisterCodec().

## ◆ magicNumberMatch()

bool Ogre::Codec::magicNumberMatch | ( | const char * | magicNumberPtr,
|  | size_t | maxbytes ) const
| inline

Returns whether a magic number header matches this codec.

Parameters

  magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  maxbytes | The number of bytes passed

References magicNumberToFileExt().

## ◆ magicNumberToFileExt()

virtual String Ogre::Codec::magicNumberToFileExt | ( | const char * | magicNumberPtr,
|  | size_t | maxbytes ) const
| pure virtual

Maps a magic number header to a file extension, if this codec recognises it.

Parameters

  magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  maxbytes | The number of bytes passed

Returns
  A blank string if the magic number was unknown, or a file extension.

Implemented in Ogre::EXRCodec, Ogre::FreeImageCodec, Ogre::RsImageCodec, and Ogre::STBIImageCodec.

Referenced by magicNumberMatch().

## ◆ setParameter()

virtual bool Ogre::Codec::setParameter | ( | const String & | name,
|  | const String & | value )
| inlinevirtual

The documentation for this class was generated from the following file:

- OgreCodec.h